package xyz.twovb.sgm.guis;


/*
 * Created by 2vb - 5/7/2024
 */

import com.github.stefvanschie.inventoryframework.gui.type.ChestGui;
import lombok.Getter;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import xyz.twovb.sgm.SGM;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.logging.Level;

public class JoinGameGui {

    @Getter
    private final ChestGui gui;

    public JoinGameGui() {
        ChestGui loadedGui = null;
        try {
            File guiFile = new File(SGM.getInstance().getDataFolder(), "guis/joingame.xml");
            if (guiFile.exists()) {
                byte[] fileContent = Files.readAllBytes(guiFile.toPath());
                InputStream inputStream = new ByteArrayInputStream(fileContent);
                loadedGui = ChestGui.load(this, inputStream);
            } else {
                SGM.getInstance().getLogger().log(Level.WARNING, "Could not find joingame.xml file.");
            }
        } catch (Exception e) {
            SGM.getInstance().getLogger().log(Level.SEVERE, "Error loading joingame.xml", e);
        }
        gui = loadedGui;
    }

    public void globalClick(InventoryClickEvent event) {
        event.setCancelled(true);
    }

    public void joinGame(InventoryClickEvent event) {
        Player player = (Player) event.getWhoClicked();
        String itemName = event.getCurrentItem().getItemMeta().getDisplayName().replaceAll("\\W+", "");
        player.closeInventory();
        if (SGM.getInstance().getGameManager().getRegisteredGames().contains(itemName.toLowerCase())) {
            new ActiveGamesGui(itemName).getGui().show(player);
        } else {
            player.sendMessage("Please check xml");
        }
    }
}
